DIR=build_$(uname -m)

function replace_cxx_flags () {
        cmake_version=$(cmake --version)
        cmake_version_number=$(expr match "$cmake_version" '.*\([0-9]\.[0-9]*\.[0-9]*\)')
        first_digit=$(expr match "$cmake_version_number" '\([0-9]*\)')
        second_digit=$(expr match "$cmake_version_number" '.*\.\([0-9]*\)\..*')
        if [ "$first_digit" -ge "3" ] || [ "$second_digit" -ge "4" ]; then
                find . -name build.make -type f -exec sed -i 's/CXX_FLAGS/CXX_FLAGS) $(CXX_INCLUDES/g' {} \;
        fi
}

#verifie l'existence du lien symbolique build
if [ -d build ];then
	if ! readlink build > /dev/null ; then
		#it is a directory, exit to do not erase anything
		err "Error: build already exsits and is a directory; it should be a symlink."
		exit 1
	fi
	if ! readlink build | grep -w $DIR >/dev/null; then
		echo "Warnink, build was pointing to another directory."
	fi
	rm build
fi

#creation du repertoire
mkdir -p $DIR
#creation du lien symbolique
ln -s $DIR build

#creation project x86
cd build

rm -f CMakeCache.txt
rm -rf CMakeFiles
${OECORE_HOST_NATIVE_SYSROOT}/usr/bin/cmake ../ -G "CodeBlocks - Unix Makefiles" -DCMAKE_TOOLCHAIN_FILE=${OECORE_CMAKE_HOST_TOOLCHAIN}
